      SUBROUTINE ARC( ITG, NS, RADA, ANG1, ANG2, RAD)
C
C     ARC GENERATES SEGMENT GEOMETRY DATA FOR AN ARC OF NS SEGMENTS
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      DIMENSION  X2(1), Y2(1), XZ2(1)
      EQUIVALENCE(X2,SI),(Y2,ALP),(XZ2,BET)
      DATA   TA/.01745329252D+0/
      IST= N+1
      N= N+ NS
      NP= N
      IPSYM=0
      IF( NS.LT.1) RETURN
      IF( ABS( ANG2- ANG1).LT.360.00001D+0) GOTO 1
      WRITE(*,3)
      STOP
    1 ANG= ANG1* TA
      DANG=( ANG2- ANG1)* TA/ NS
      IF(IRADCO.EQ.0)GOTO 2002
      RADWL=RAD*GSVAL/WLAM
      if(iradco.ne.9.and.(RADWL.LT..001.OR.RADWL.GT..003))GOTO 2007
      SLEN=SIN(DANG)*RADA
      RADZ= RAD*( 0.94 + 2.7 * SLEN*GSVAL/WLAM)
      GOTO 2003
 2007 WRITE(*,*)'Element radius outside range for modified NEC'
      WRITE(*,*)'Use original NEC  -  Option MO  0 in PARNR.NEC'
      STOP
 2002 RADZ=RAD
 2003 XS1= RADA* COS( ANG)
      RZS1= RADA* SIN( ANG)
      IF(N.GT.NM)GOTO 944
      DO 2  I= IST, N
      ANG= ANG+ DANG
      XS2= RADA* COS( ANG)
      RZS2= RADA* SIN( ANG)
      X( I)= XS1
      Y( I)=0.
      RXZ( I)= RZS1
      X2( I)= XS2
      Y2( I)=0.
      XZ2( I)= RZS2
      XS1= XS2
      RZS1= RZS2
      BI( I)= RADZ
      BI0(I)=RAD
    2 ITAG( I)= ITG
C
      RETURN
 944  WRITE(*,*)'Too many segments (arc)'
      STOP
    3 FORMAT(' ERROR -- ARC ANGLE EXCEEDS 360. DEGREES')
      END
