      SUBROUTINE GF( UZK, CO, SI)
C     GF COMPUTES THE INTEGRAND EXP(JKR)/(KR) FOR NUMERICAL INTEGRATION.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMMON  /TMI/ UZPK, RKB2, IJ
      UZDK= UZK- UZPK
      RK= SQRT( RKB2+ UZDK* UZDK)
      SI= SIN( RK)/ RK
      IF( IJ) 1,2,1
    1 CO= COS( RK)/ RK
      RETURN
    2 IF( RK.LT..2D0) GOTO 3
      CO=( COS( RK)-1)/ RK
      RETURN
    3 RKS= RK* RK
      CO=((-1.38888888888888889D-3* RKS+4.16666666666666667D-2)* RKS
     & -.5D0)* RK
      RETURN
      END
